#include <math.h>
#include <iostream>
#include "mpi.h"
#include <cstdlib>
using namespace std;

int* Snakey(int start, int range, int server_count, int processor_count, int subRank, int subGroup)
{
	        int i = 0;                      //Mike's favorite index variables
        int j = 0;
        int k = 0;
        int adder = 0;                  //used for "priming" of the first layer of 3D array
        int job = 0;                    //ditto
        int level = 0;                  //this is the level number, or 3rd dimension, or "slice" of the array
        int count = 0;                  //this is the current count of which N1 is being generated

        //input variables
/*        int start = 0;                  //where do you want N1 to begin?
        int range = 100;                //how many N1's are to be generated
        int server_count = 4;           //number of servers we're working on
        int processor_count = 6;        //number of cores to use on each server

        cout << "Where do you want \"n1\" to begin? ";
        cin >> start;
        cout << "How many \"n1's\" do you want to be generated? ";
        cin >> range;
        cout << "How many servers (not processors) do you want to use? ";
        cin >> server_count;
*/
 	int core_job_count = range / (server_count * processor_count) + 1;
                                        //number of cycles processed per core
                                        //also can be thought of as the "depth" of the 3D array
                                        //it is recommended for "range" to be greater than "servers x cores"
	cout << "Subgroup " << subGroup << " Subrank " << subRank << " CoreJobCount " << core_job_count << endl;        //create 3D array
        //if server_count = 4 and processor_count = 6 then
        //core_job_count = 5 and we create a 4x6x5 3D array
        //note that N's elements are N[0][0][0] through N[3][5][4]

        int *** N = new int**[server_count];    //Pretty neat, eh? A triple pointer!
        for (i = 0; i < server_count; i++)
        {
                N[i] = new int*[processor_count];
                for (j = 0; j < processor_count; j++)
                {
                        N[i][j] = new int[core_job_count];
                        for (k = 0; k < core_job_count; k++)
                                N[i][j][k] = 0;         //init all values to 0
                }
        }

        //populate array N
	//do level 0 separately (prime) as there are no previous values to build upon
        if (level == 0)
        {
                adder = server_count * 2 + 1;
                for (i = 0; i < server_count; i++)
                {
                        adder = adder - 2;
                        job = i;
                        N[i][0][0] = job;
                        for (j = 1; j < processor_count; j++)
                        {
                                if (j % 2 == 1)
                                        job = job + adder;
                                else
                                        job = job + (server_count * 2 - adder);
                                N[i][j][0] = job;
                        }
        //                cout << endl << endl;
                }
        }                

        //now the other levels, layers or "slices"        
        for (level = 1; level < core_job_count; level++)
        {
                for (i = 0; i < server_count; i++)
                {

                        for (j = 0; j < processor_count; j++)
                        {
                                if (level % 2 == 0)
                                        N[i][j][level] = 2 * server_count * processor_count + N[i][j][level -2];
                                else
                                        N[i][j][level] = 2 * level * server_count * processor_count - N[i][j][level - 1] -1;
                        }
                }
        }

        //cut off tail ends and add the N's to the starting number
        for (level = 0; level < core_job_count; level++)
                for (i = 0; i < server_count; i++)
                        for (j = 0; j < processor_count; j++)
                        {
                                N[i][j][level] = N[i][j][level] + start;
                                if (N[i][j][level] >= start + range)
                                        N[i][j][level] = 0;
                        }

        //display levels
/*        for (level = 0; level < core_job_count; level++)
        {
                cout << "LEVEL " << level << endl;                
                for (i = 0; i < server_count; i++)      
                {

                       for (j = 0; j < processor_count; j++)
                                cout << N[i][j][level] << "  ";
                        cout << endl;
                }
                cout << endl << endl;
        }
*/
	cout << "Subgroup " << subGroup << " Subrank " << subRank << " CoreJobCount " << core_job_count << " DONE!" <<  endl;
        //create 3D array
	
	// return 1D array at location [subGroup][subRank - 1]
        return N[subGroup][subRank - 1];
}

int main(int argc, char *argv[])
{
	int thenumber = 0; // used to test the group BCAST stuff
	int i = 0;
//	int start = atoi(argv[1]);
//	int range = atoi(argv[2]);
	int start = 100;
	int range = 150;
	int rank, size; // for COMM_WORLD info
	int namelength = 0; // used for printing out the name of the compute node
	int computenodes = 4; // number of compute nodes on cluster, hopefully this will increase


	int group_num = 0; // used to determine which group each node should belong to
	int group_rank = 0; // for the rank within the group
	int group_size = 0; // for the size within the group

	MPI::Init(argc, argv);
	char name[MPI_MAX_PROCESSOR_NAME];  // create character array for the names of the compute nodes

	MPI::Intracomm COMM_GROUP;  // used to create subgroups corresponding to each compute node

	size = MPI::COMM_WORLD.Get_size();
	rank = MPI::COMM_WORLD.Get_rank();
	
	// we can use this for debugging, each process can now tell us what compute node they are on
	MPI::Get_processor_name(name, namelength);

	// this should group all the process on each compute node into the same group_num, assuming even distribution
	group_num = floor(rank/(size/computenodes)); 

	// now we use the MPI.Split to break up our processes based on group number and their current rank
	// then note that we get the new group size and group rank almost like we do at MPI initialize time...
	COMM_GROUP = MPI::COMM_WORLD.Split(group_num, rank);
	group_size = COMM_GROUP.Get_size();
	group_rank = COMM_GROUP.Get_rank();

	if(group_rank != 0)
	{
		//cout << "Rank " << rank << " "  << range/(computenodes * (group_size - 1)) + 1 << endl;
		//int* Snakey(int start, int range, int server_count, int processor_count, int subRank, int subGroup)

		//int *ptr = new int[range/(computenodes * (group_size - 1)) + 1];
		//ptr = Snakey(start, range, computenodes, group_size - 1, group_rank, group_size);
		int *ptr =  Snakey(start, range, computenodes, group_size - 1, group_rank, group_size);
 		
		
		for(i = 0; i < range/(computenodes * (group_size - 1)) + 1; i++)
		{			
			//cout << "Rank " << rank << " "  << range/(computenodes * (group_size - 1)) + 1 <<  endl;		 
	       		cout << "Process " << rank <<"/" << size << "(" << name << "): Group - " << group_num << ", Group size - " << group_size << ", Group rank - " << group_rank << ", our Number " << i <<  " = " << *(ptr + i) << endl;
		}	
	       		cout << "Process " << rank <<"/" << size << "(" << name << "): Group - " << group_num << ", Group size - " << group_size << ", Group rank - " << group_rank << " DONE! "<< endl;

	}
	// let's now test everything, make sure we have our groups built correctly
        //cout << "Process " << rank <<"/" << size << "(" << name << "): Group - " << group_num <<  ", Group size - " << group_size << ", Group rank - " << group_rank << endl;

	// now let's play around with local variables
/*	if (group_rank == 0)
	{
		thenumber = 1000 + group_num;
	}

        cout << "Process " << rank <<"/" << size << "(" << name << "): Group - " << group_num <<  ", Group size - " << group_size << ", Group rank - " << group_rank << ", before Bcast # = " << thenumber << endl;

	// now let's do a local braodcast!
	COMM_GROUP.Bcast(&thenumber, 1, MPI::INT,0);
        cout << "Process " << rank <<"/" << size << "(" << name << "): Group - " << group_num <<  ", Group size - " << group_size << ", Group rank - " << group_rank << ", after Bcast # = " << thenumber << endl;
*/
	// free up memory be deleting the subcommunications group
	COMM_GROUP.Free();

	MPI::Finalize();
	return 0;
}
