#include <iostream>
#include <string.h>
#include <cstdlib>
using namespace std;

int n[3];
int k[3];

int cur_update(int side, int x)
{
	if ((x + k[side]) == n[side])
		return  n[side];
	else
		return (x + k[side]) % n[side];
}

int main()
{
	int i = 0;
	int l[3] = {0};
	int m[3] = {0};

	cout << "Enter n1, k1, n2, k2 : ";
	cin >> n[1] >> k[1] >> n[2] >> k[2];

	bool * P = new bool[n[2]];
	P[0] = 1; 
	for (i = 1; i <= n[2];i++)
		P[i] = 0;
	//P[n] = 0 means P[n] is an available starting point for a new disjoint cycle
	//P[n] = 1 means P[n] has been used in a previous disjoint cycle
	
	bool finished = false;
	bool cycle_built = false;
	int start_num; 		// this is the first number in the disjoint cycle
	int current_num; 	// this is a subsequent number in the current disjoint cycle

while (!finished)
{   
    //create another disjoint cycle at next available starting point
    for(i = 1; i <= n[2]; i++)
    {
	if (P[i] == 0)
	{
		start_num = i;
		P[i] = 1;
		break;
	}
    }
   
    if(i > n[2])	//all numbers on the right side are exhausted, like me
    {
	finished = true;
	cout << "\nFINISHED!\n";
 	break;
    }

    cycle_built = false;
    while (!cycle_built) //i.e., there's work to be done
    {
	cout << "( " << start_num << " ";
	// evaluate right side functional value of the start_num
	current_num = cur_update(2, start_num);
	// at this point, current_num is the right side functional value of the start_num
	// e.g., (1234)^3 is right side, start_num is 3 and k2 = 2 yields current_num = 1 
	
	// NOW, build the rest of the cycle!

    	while (current_num != start_num)
    	{
		// now go after left side functional value of current_num
	
		current_num = cur_update(1, current_num);

		while (current_num != start_num)
		{
			if (P[current_num] == 0)
			{
				P[current_num] = 1;
				cout << current_num << " ";
				//see which side to go to
				if (current_num <= n[2])
					current_num = cur_update(2, current_num);
				current_num = cur_update(1, current_num);
			}
			else
			{
				current_num = cur_update(1, current_num);
				cout << current_num;
			}
		}
		cout << ")";
		cycle_built = true;
    	}
    }	
}
    return 0;
}

