#include <iostream>
#include <cstdlib>
using namespace std;

int main()
{
	int i = 0;			//Mike's favorite index variables
	int j = 0;
	int k = 0;
	int adder = 0;			//used for "priming" of the first layer of 3D array
	int job = 0;			//ditto
	int level = 0;			//this is the level number, or 3rd dimension, or "slice" of the array
	int count = 0;			//this is the current count of which N1 is being generated

	//input variables
	int start = 0;			//where do you want N1 to begin?
	int range = 100;		//how many N1's are to be generated
	int server_count = 4;		//number of servers we're working on
	int processor_count = 6;	//number of cores to use on each server

	cout << "Where do you want \"n1\" to begin? ";
	cin >> start;
	cout << "How many \"n1's\" do you want to be generated? ";
	cin >> range;
	cout << "How many servers (not processors) do you want to use? ";
	cin >> server_count;
	cout << "How many processors per server do you want to use? ";
	cin >> processor_count;

	int core_job_count = range / (server_count * processor_count) + 1;  
					//number of cycles processed per core
					//also can be thought of as the "depth" of the 3D array
					//it is recommended for "range" to be greater than "servers x cores"

	//create 3D array
	//if server_count = 4 and processor_count = 6 then
	//core_job_count = 5 and we create a 4x6x5 3D array
	//note that N's elements are N[0][0][0] through N[3][5][4]
	
	int *** N = new int**[server_count];	//Pretty neat, eh? A triple pointer!
	for (i = 0; i < server_count; i++)
	{
		N[i] = new int*[processor_count];
		for (j = 0; j < processor_count; j++)
		{
			N[i][j] = new int[core_job_count];
			for (k = 0; k < core_job_count; k++)
				N[i][j][k] = 0;		//init all values to 0
		}	
	}

	//populate array N
	//do level 0 separately (prime) as there are no previous values to build upon
	if (level == 0)
	{
		adder = server_count * 2 + 1;
		for (i = 0; i < server_count; i++)
		{
			adder = adder - 2;
			job = i;
			N[i][0][0] = job;
			for (j = 1; j < processor_count; j++)
			{	
				if (j % 2 == 1)
					job = job + adder;
				else
					job = job + (server_count * 2 - adder);
				N[i][j][0] = job;
			}	
			cout << endl << endl;
		}
	}

	//now the other levels, layers or "slices"
	for (level = 1; level < core_job_count; level++)
	{
		for (i = 0; i < server_count; i++)
		{	
			for (j = 0; j < processor_count; j++)
			{
				if (level % 2 == 0)
					N[i][j][level] = 2 * server_count * processor_count + N[i][j][level - 2];
				else
					N[i][j][level] = 2 * level * server_count * processor_count - N[i][j][level - 1] - 1;
			}
		}
	}

	//cut off tail ends and add the N's to the starting number
	for (level = 0; level < core_job_count; level++)
		for (i = 0; i < server_count; i++)
			for (j = 0; j < processor_count; j++)
			{
				N[i][j][level] = N[i][j][level] + start;
				if (N[i][j][level] >= start + range)
					N[i][j][level] = 0;
			}

	//display levels
	for (level = 0; level < core_job_count; level++)
	{
		cout << "LEVEL " << level << endl;
		for (i = 0; i < server_count; i++)
		{
			for (j = 0; j < processor_count; j++)
				cout << N[i][j][level] << "  ";
			cout << endl;
		}
		cout << endl << endl;
	}

	return 0;
}

